<script>
  import {max, extent} from 'd3-array';
  import {scaleLinear, scaleLog, scaleOrdinal} from 'd3-scale';
  import {axisBottom, axisLeft} from "d3-axis";
  import {select} from "d3-selection";
  import {schemeSet2} from "d3-scale-chromatic";

  
  // Dimensions
  export let data = null;
  const [height, width] = [400, 600];
  const margin = { top: 50, right: 5, bottom: 55, left: 50 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;

  let continents = [];
  for(let i=0; i < data.length; i++){
    continents.push(data[i].continent);
  }

  let x_scaler = scaleLog().domain([300, 130000]).range([0, innerWidth]);
  let y_scaler = scaleLinear().domain([90, 0]).range([0, innerHeight]);
  let r_scaler = scaleLinear().domain([0, 421675014]).range([5, 8]);
  let color_scaler = scaleOrdinal().domain(extent(continents)).range(schemeSet2)

  let left_axis = axisLeft(y_scaler);
  let bottom_axis = axisBottom(x_scaler);

  function addLeftAxis(){
    select("#left_axis_ex7").call(left_axis);
  }
  function addBottomAxis(){
    // 
    bottom_axis.tickValues([400, 4000, 40000]);
    bottom_axis.ticks(2).tickFormat(function(d) {
      return "$" + d;
    });
    // 
    select("#bottom_axis_ex7").call(bottom_axis);
  }

</script>


<svg viewBox="0 0 {width} {height}" style="max-width: {width}px">
  <text x={innerWidth/2 - 100}, y={margin.top} font-size="2em">Gapminder Scatterplot</text>
  <text x="-{innerHeight/2}" y=130 transform="rotate(-90 0 115)">Life Expectancy</text>
  <g id="left_axis_ex7" use:addLeftAxis transform={`translate(${margin.left}, ${margin.top})`}>
  </g>
  <g transform="translate({margin.left}, {margin.top})">
    <!--  -->
    {#each data as d}
    {#if d.income != null & d.life_exp != null & d.population != null & d.population != NaN & d.income != NaN}
      <circle cx={x_scaler(+d.income)} cy={y_scaler(+d.life_exp)} r={r_scaler(+d.population)} fill="{color_scaler(d.continent)}" />
    {/if}
    {/each}
  </g>
  <g id="bottom_axis_ex7" use:addBottomAxis transform={`translate(${margin.left}, ${height-margin.bottom})`}></g>
  <text x={innerWidth/2} y={height - margin.bottom / 3}>GDP per Capita</text>
  <text x={innerWidth-40} y={innerHeight+30} font-size="2.5em" fill="grey">1800</text>
</svg>

